# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: flow/legacy/access/access.proto for package 'access'

require 'grpc'
require 'flow/legacy/access/access_pb'

module Access
  module AccessAPI
    # AccessAPI is the public-facing API provided by access nodes.
    class Service

      include ::GRPC::GenericService

      self.marshal_class_method = :encode
      self.unmarshal_class_method = :decode
      self.service_name = 'access.AccessAPI'

      # Ping is used to check if the access node is alive and healthy.
      rpc :Ping, ::Access::PingRequest, ::Access::PingResponse
      # Block Headers
      #
      # GetLatestBlockHeader gets the latest sealed or unsealed block header.
      rpc :GetLatestBlockHeader, ::Access::GetLatestBlockHeaderRequest, ::Access::BlockHeaderResponse
      # GetBlockHeaderByID gets a block header by ID.
      rpc :GetBlockHeaderByID, ::Access::GetBlockHeaderByIDRequest, ::Access::BlockHeaderResponse
      # GetBlockHeaderByHeight gets a block header by height.
      rpc :GetBlockHeaderByHeight, ::Access::GetBlockHeaderByHeightRequest, ::Access::BlockHeaderResponse
      # Blocks
      #
      # GetLatestBlock gets the full payload of the latest sealed or unsealed
      # block.
      rpc :GetLatestBlock, ::Access::GetLatestBlockRequest, ::Access::BlockResponse
      # GetBlockByID gets a full block by ID.
      rpc :GetBlockByID, ::Access::GetBlockByIDRequest, ::Access::BlockResponse
      # GetBlockByHeight gets a full block by height.
      rpc :GetBlockByHeight, ::Access::GetBlockByHeightRequest, ::Access::BlockResponse
      # Collections
      #
      # GetCollectionByID gets a collection by ID.
      rpc :GetCollectionByID, ::Access::GetCollectionByIDRequest, ::Access::CollectionResponse
      # Transactions
      #
      # SendTransaction submits a transaction to the network.
      rpc :SendTransaction, ::Access::SendTransactionRequest, ::Access::SendTransactionResponse
      # GetTransaction gets a transaction by ID.
      rpc :GetTransaction, ::Access::GetTransactionRequest, ::Access::TransactionResponse
      # GetTransactionResult gets the result of a transaction.
      rpc :GetTransactionResult, ::Access::GetTransactionRequest, ::Access::TransactionResultResponse
      # Accounts
      #
      # GetAccount is an alias for GetAccountAtLatestBlock.
      #
      # Warning: this function is deprecated. It behaves identically to
      # GetAccountAtLatestBlock and will be removed in a future version.
      rpc :GetAccount, ::Access::GetAccountRequest, ::Access::GetAccountResponse
      # GetAccountAtLatestBlock gets an account by address from the latest sealed
      # execution state.
      rpc :GetAccountAtLatestBlock, ::Access::GetAccountAtLatestBlockRequest, ::Access::AccountResponse
      # GetAccountAtBlockHeight gets an account by address at the given block
      # height
      rpc :GetAccountAtBlockHeight, ::Access::GetAccountAtBlockHeightRequest, ::Access::AccountResponse
      # Scripts
      #
      # ExecuteScriptAtLatestBlock executes a read-only Cadence script against the
      # latest sealed execution state.
      rpc :ExecuteScriptAtLatestBlock, ::Access::ExecuteScriptAtLatestBlockRequest, ::Access::ExecuteScriptResponse
      # ExecuteScriptAtBlockID executes a ready-only Cadence script against the
      # execution state at the block with the given ID.
      rpc :ExecuteScriptAtBlockID, ::Access::ExecuteScriptAtBlockIDRequest, ::Access::ExecuteScriptResponse
      # ExecuteScriptAtBlockHeight executes a ready-only Cadence script against the
      # execution state at the given block height.
      rpc :ExecuteScriptAtBlockHeight, ::Access::ExecuteScriptAtBlockHeightRequest, ::Access::ExecuteScriptResponse
      # Events
      #
      # GetEventsForHeightRange retrieves events emitted within the specified block
      # range.
      rpc :GetEventsForHeightRange, ::Access::GetEventsForHeightRangeRequest, ::Access::EventsResponse
      # GetEventsForBlockIDs retrieves events for the specified block IDs and event
      # type.
      rpc :GetEventsForBlockIDs, ::Access::GetEventsForBlockIDsRequest, ::Access::EventsResponse
      # NetworkParameters
      #
      # GetNetworkParameters retrieves the Flow network details
      rpc :GetNetworkParameters, ::Access::GetNetworkParametersRequest, ::Access::GetNetworkParametersResponse
    end

    Stub = Service.rpc_stub_class
  end
end
